// Code generated by mockery v2.16.0. DO NOT EDIT.

package mockStorage

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	event_log "gitlab.com/ka.ra.il/grpc-contract-test/internal/coin/domain/event_log"

	queryParameter "gitlab.com/ka.ra.il/grpc-contract-test/pkg/type/queryParameter"
)

// EventLog is an autogenerated mock type for the EventLog type
type EventLog struct {
	mock.Mock
}

// CountEventLog provides a mock function with given fields: ctx
func (_m *EventLog) CountEventLog(ctx context.Context) (uint64, error) {
	ret := _m.Called(ctx)

	var r0 uint64
	if rf, ok := ret.Get(0).(func(context.Context) uint64); ok {
		r0 = rf(ctx)
	} else {
		r0 = ret.Get(0).(uint64)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(context.Context) error); ok {
		r1 = rf(ctx)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// CreateEventLog provides a mock function with given fields: ctx, event
func (_m *EventLog) CreateEventLog(ctx context.Context, event ...*event_log.EventLog) ([]*event_log.EventLog, error) {
	_va := make([]interface{}, len(event))
	for _i := range event {
		_va[_i] = event[_i]
	}
	var _ca []interface{}
	_ca = append(_ca, ctx)
	_ca = append(_ca, _va...)
	ret := _m.Called(_ca...)

	var r0 []*event_log.EventLog
	if rf, ok := ret.Get(0).(func(context.Context, ...*event_log.EventLog) []*event_log.EventLog); ok {
		r0 = rf(ctx, event...)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]*event_log.EventLog)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(context.Context, ...*event_log.EventLog) error); ok {
		r1 = rf(ctx, event...)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteEventLog provides a mock function with given fields: ctx, TxHash
func (_m *EventLog) DeleteEventLog(ctx context.Context, TxHash string) error {
	ret := _m.Called(ctx, TxHash)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, string) error); ok {
		r0 = rf(ctx, TxHash)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetLastBlockNumber provides a mock function with given fields: ctx, addressContract
func (_m *EventLog) GetLastBlockNumber(ctx context.Context, addressContract string) (int64, error) {
	ret := _m.Called(ctx, addressContract)

	var r0 int64
	if rf, ok := ret.Get(0).(func(context.Context, string) int64); ok {
		r0 = rf(ctx, addressContract)
	} else {
		r0 = ret.Get(0).(int64)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, addressContract)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// ListEventLog provides a mock function with given fields: ctx, parameter
func (_m *EventLog) ListEventLog(ctx context.Context, parameter queryParameter.QueryParameter) ([]*event_log.EventLog, error) {
	ret := _m.Called(ctx, parameter)

	var r0 []*event_log.EventLog
	if rf, ok := ret.Get(0).(func(context.Context, queryParameter.QueryParameter) []*event_log.EventLog); ok {
		r0 = rf(ctx, parameter)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]*event_log.EventLog)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(context.Context, queryParameter.QueryParameter) error); ok {
		r1 = rf(ctx, parameter)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// ReadEventLogByTxHash provides a mock function with given fields: ctx, TxHash
func (_m *EventLog) ReadEventLogByTxHash(ctx context.Context, TxHash string) (*event_log.EventLog, error) {
	ret := _m.Called(ctx, TxHash)

	var r0 *event_log.EventLog
	if rf, ok := ret.Get(0).(func(context.Context, string) *event_log.EventLog); ok {
		r0 = rf(ctx, TxHash)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*event_log.EventLog)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, TxHash)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateEventLog provides a mock function with given fields: ctx, TxHash, updateFn
func (_m *EventLog) UpdateEventLog(ctx context.Context, TxHash string, updateFn func(*event_log.EventLog) (*event_log.EventLog, error)) (*event_log.EventLog, error) {
	ret := _m.Called(ctx, TxHash, updateFn)

	var r0 *event_log.EventLog
	if rf, ok := ret.Get(0).(func(context.Context, string, func(*event_log.EventLog) (*event_log.EventLog, error)) *event_log.EventLog); ok {
		r0 = rf(ctx, TxHash, updateFn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*event_log.EventLog)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(context.Context, string, func(*event_log.EventLog) (*event_log.EventLog, error)) error); ok {
		r1 = rf(ctx, TxHash, updateFn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

type mockConstructorTestingTNewEventLog interface {
	mock.TestingT
	Cleanup(func())
}

// NewEventLog creates a new instance of EventLog. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewEventLog(t mockConstructorTestingTNewEventLog) *EventLog {
	mock := &EventLog{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
